]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
t5550: break submodule config test into multiple sub-tests
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
967b2c66
JS
49# The function takes at most 2 arguments. The first argument is the
50# URL that navigates to the submodule origin repo. When relative, this URL
51# is relative to the superproject origin URL repo. The second up_path
52# argument, if specified, is the relative path that navigates
53# from the submodule working tree to the superproject working tree.
54#
55# The output of the function is the origin URL of the submodule.
56#
57# The output will either be an absolute URL or filesystem path (if the
58# superproject origin URL is an absolute URL or filesystem path,
59# respectively) or a relative file system path (if the superproject
60# origin URL is a relative file system path).
61#
62# When the output is a relative file system path, the path is either
63# relative to the submodule working tree, if up_path is specified, or to
64# the superproject working tree otherwise.
f31a522a
ML
65resolve_relative_url ()
66{
98fcf840 67 remote=$(get_default_remote)
8e7e6f39 68 remoteurl=$(git config "remote.$remote.url") ||
4d689320 69 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 70 url="$1"
99b120af 71 remoteurl=${remoteurl%/}
ea640cc6 72 sep=/
967b2c66
JS
73 up_path="$2"
74
75 case "$remoteurl" in
76 *:*|/*)
77 is_relative=
78 ;;
758615e2
JS
79 ./*|../*)
80 is_relative=t
81 ;;
967b2c66
JS
82 *)
83 is_relative=t
758615e2 84 remoteurl="./$remoteurl"
967b2c66
JS
85 ;;
86 esac
87
f31a522a
ML
88 while test -n "$url"
89 do
90 case "$url" in
91 ../*)
92 url="${url#../}"
ea640cc6
TR
93 case "$remoteurl" in
94 */*)
95 remoteurl="${remoteurl%/*}"
96 ;;
97 *:*)
98 remoteurl="${remoteurl%:*}"
99 sep=:
100 ;;
101 *)
758615e2
JS
102 if test -z "$is_relative" || test "." = "$remoteurl"
103 then
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
105 else
106 remoteurl=.
107 fi
ea640cc6
TR
108 ;;
109 esac
f31a522a
ML
110 ;;
111 ./*)
112 url="${url#./}"
113 ;;
114 *)
115 break;;
116 esac
117 done
758615e2
JS
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
120}
121
091a6eb0
JK
122# Resolve a path to be relative to another path. This is intended for
123# converting submodule paths when git-submodule is run in a subdirectory
124# and only handles paths where the directory separator is '/'.
125#
126# The output is the first argument as a path relative to the second argument,
127# which defaults to $wt_prefix if it is omitted.
128relative_path ()
129{
130 local target curdir result
131 target=$1
132 curdir=${2-$wt_prefix}
133 curdir=${curdir%/}
134 result=
135
136 while test -n "$curdir"
137 do
138 case "$target" in
139 "$curdir/"*)
140 target=${target#"$curdir"/}
141 break
142 ;;
143 esac
144
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
147 then
148 curdir=
149 else
150 curdir="${curdir%/*}"
151 fi
152 done
153
154 echo "$result$target"
155}
156
be9d0a3a
HV
157die_if_unmatched ()
158{
159 if test "$1" = "#unmatched"
160 then
161 exit 1
162 fi
163}
164
88ce00c3
TK
165#
166# Print a submodule configuration setting
167#
168# $1 = submodule name
169# $2 = option name
170# $3 = default value
171#
172# Checks in the usual git-config places first (for overrides),
173# otherwise it falls back on .gitmodules. This allows you to
174# distribute project-wide defaults in .gitmodules, while still
175# customizing individual repositories if necessary. If the option is
176# not in .gitmodules either, print a default value.
177#
178get_submodule_config () {
179 name="$1"
180 option="$2"
181 default="$3"
182 value=$(git config submodule."$name"."$option")
183 if test -z "$value"
184 then
185 value=$(git config -f .gitmodules submodule."$name"."$option")
186 fi
187 printf '%s' "${value:-$default}"
188}
189
862ae6cd
RS
190isnumber()
191{
192 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
193}
194
14111fc4
JK
195# Sanitize the local git environment for use within a submodule. We
196# can't simply use clear_local_git_env since we want to preserve some
197# of the settings from GIT_CONFIG_PARAMETERS.
198sanitize_submodule_env()
199{
200 sanitized_config=$(git submodule--helper sanitize-config)
201 clear_local_git_env
202 GIT_CONFIG_PARAMETERS=$sanitized_config
203}
204
ecda0723
SV
205#
206# Add a new submodule to the working tree, .gitmodules and the index
207#
ec05df35 208# $@ = repo path
ecda0723
SV
209#
210# optional branch is stored in global branch variable
211#
23a485e3 212cmd_add()
ecda0723 213{
5c08dbbd 214 # parse $args after "submodule ... add".
091a6eb0 215 reference_path=
5c08dbbd
JH
216 while test $# -ne 0
217 do
218 case "$1" in
219 -b | --branch)
220 case "$2" in '') usage ;; esac
221 branch=$2
222 shift
223 ;;
d27b876b
JL
224 -f | --force)
225 force=$1
226 ;;
5c08dbbd 227 -q|--quiet)
2e6a30ef 228 GIT_QUIET=1
5c08dbbd 229 ;;
d92a3959
MT
230 --reference)
231 case "$2" in '') usage ;; esac
091a6eb0 232 reference_path=$2
d92a3959
MT
233 shift
234 ;;
235 --reference=*)
091a6eb0 236 reference_path="${1#--reference=}"
d92a3959 237 ;;
73b0898d
JL
238 --name)
239 case "$2" in '') usage ;; esac
240 custom_name=$2
241 shift
242 ;;
275cd184
FG
243 --depth)
244 case "$2" in '') usage ;; esac
245 depth="--depth=$2"
246 shift
247 ;;
248 --depth=*)
249 depth=$1
250 ;;
5c08dbbd
JH
251 --)
252 shift
253 break
254 ;;
255 -*)
256 usage
257 ;;
258 *)
259 break
260 ;;
261 esac
262 shift
263 done
264
091a6eb0
JK
265 if test -n "$reference_path"
266 then
267 is_absolute_path "$reference_path" ||
268 reference_path="$wt_prefix$reference_path"
269
270 reference="--reference=$reference_path"
271 fi
272
ecda0723 273 repo=$1
64394e3a 274 sm_path=$2
ecda0723 275
64394e3a 276 if test -z "$sm_path"; then
6a066230 277 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
278 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
279 fi
280
496eeeb1 281 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
282 usage
283 fi
284
091a6eb0
JK
285 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
286
ec05df35
ML
287 # assure repo is absolute or relative to parent
288 case "$repo" in
289 ./*|../*)
091a6eb0
JK
290 test -z "$wt_prefix" ||
291 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
292
ec05df35
ML
293 # dereference source url relative to parent's url
294 realrepo=$(resolve_relative_url "$repo") || exit
295 ;;
296 *:*|/*)
297 # absolute url
298 realrepo=$repo
299 ;;
300 *)
497ee872 301 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
302 ;;
303 esac
304
db75ada5
MG
305 # normalize path:
306 # multiple //; leading ./; /./; /../; trailing /
64394e3a 307 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
308 sed -e '
309 s|//*|/|g
310 s|^\(\./\)*||
8196e728 311 s|/\(\./\)*|/|g
db75ada5
MG
312 :start
313 s|\([^/]*\)/\.\./||
314 tstart
315 s|/*$||
316 ')
64394e3a
RJ
317 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
318 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 319
64394e3a 320 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 321 then
6ff875c5 322 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 323\$sm_path
6ff875c5 324Use -f if you really want to add it." >&2
d27b876b
JL
325 exit 1
326 fi
327
73b0898d
JL
328 if test -n "$custom_name"
329 then
330 sm_name="$custom_name"
331 else
332 sm_name="$sm_path"
333 fi
334
d4264ca3 335 # perhaps the path exists and is already a git repo, else clone it
64394e3a 336 if test -e "$sm_path"
d4264ca3 337 then
496eeeb1 338 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 339 then
64394e3a 340 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 341 else
64394e3a 342 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 343 fi
c2f93917 344
d4264ca3 345 else
4b7c286e
JL
346 if test -d ".git/modules/$sm_name"
347 then
348 if test -z "$force"
349 then
350 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
351 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
352 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
353 echo >&2 " $realrepo"
354 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
355 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
356 else
357 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
358 fi
359 fi
d10e3b42 360 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 361 (
14111fc4 362 sanitize_submodule_env
d851ffb9
JH
363 cd "$sm_path" &&
364 # ash fails to wordsplit ${branch:+-b "$branch"...}
365 case "$branch" in
366 '') git checkout -f -q ;;
367 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
368 esac
369 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 370 fi
73b0898d 371 git config submodule."$sm_name".url "$realrepo"
d4264ca3 372
64394e3a
RJ
373 git add $force "$sm_path" ||
374 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 375
73b0898d
JL
376 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
377 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
378 if test -n "$branch"
379 then
380 git config -f .gitmodules submodule."$sm_name".branch "$branch"
381 fi &&
31991b02 382 git add --force .gitmodules ||
64394e3a 383 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
384}
385
19a31f9c
ML
386#
387# Execute an arbitrary command sequence in each checked out
388# submodule
389#
390# $@ = command to execute
391#
392cmd_foreach()
393{
1d5bec8b
JH
394 # parse $args after "submodule ... foreach".
395 while test $# -ne 0
396 do
397 case "$1" in
398 -q|--quiet)
399 GIT_QUIET=1
400 ;;
15fc56a8
JH
401 --recursive)
402 recursive=1
403 ;;
1d5bec8b
JH
404 -*)
405 usage
406 ;;
407 *)
408 break
409 ;;
410 esac
411 shift
412 done
413
f030c96d
ÆAB
414 toplevel=$(pwd)
415
4dca1aa6
BC
416 # dup stdin so that it can be restored when running the external
417 # command in the subshell (and a recursive call to this function)
418 exec 3<&0
419
74703a1e 420 git submodule--helper list --prefix "$wt_prefix"|
64394e3a 421 while read mode sha1 stage sm_path
19a31f9c 422 do
be9d0a3a 423 die_if_unmatched "$mode"
64394e3a 424 if test -e "$sm_path"/.git
19a31f9c 425 then
091a6eb0
JK
426 displaypath=$(relative_path "$sm_path")
427 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
0ea306ef 428 name=$(git submodule--helper name "$sm_path")
15fc56a8 429 (
64394e3a 430 prefix="$prefix$sm_path/"
14111fc4 431 sanitize_submodule_env
64394e3a 432 cd "$sm_path" &&
091a6eb0
JK
433 sm_path=$(relative_path "$sm_path") &&
434 # we make $path available to scripts ...
435 path=$sm_path &&
1c4fb136
AK
436 if test $# -eq 1
437 then
438 eval "$1"
439 else
440 "$@"
441 fi &&
15fc56a8
JH
442 if test -n "$recursive"
443 then
444 cmd_foreach "--recursive" "$@"
445 fi
4dca1aa6 446 ) <&3 3<&- ||
091a6eb0 447 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
448 fi
449 done
450}
451
70c7ac22 452#
211b7f19 453# Register submodules in .git/config
70c7ac22
LH
454#
455# $@ = requested paths (default to all)
456#
23a485e3 457cmd_init()
70c7ac22 458{
5c08dbbd
JH
459 # parse $args after "submodule ... init".
460 while test $# -ne 0
461 do
462 case "$1" in
463 -q|--quiet)
2e6a30ef 464 GIT_QUIET=1
5c08dbbd
JH
465 ;;
466 --)
467 shift
468 break
469 ;;
470 -*)
471 usage
472 ;;
473 *)
474 break
475 ;;
476 esac
477 shift
478 done
479
74703a1e 480 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 481 while read mode sha1 stage sm_path
70c7ac22 482 do
be9d0a3a 483 die_if_unmatched "$mode"
0ea306ef 484 name=$(git submodule--helper name "$sm_path") || exit
c1c259e2 485
091a6eb0
JK
486 displaypath=$(relative_path "$sm_path")
487
c1c259e2 488 # Copy url setting when it is not set yet
2cd9de3e
JL
489 if test -z "$(git config "submodule.$name.url")"
490 then
491 url=$(git config -f .gitmodules submodule."$name".url)
492 test -z "$url" &&
091a6eb0 493 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
494
495 # Possibly a url relative to parent
496 case "$url" in
497 ./*|../*)
498 url=$(resolve_relative_url "$url") || exit
499 ;;
500 esac
501 git config submodule."$name".url "$url" ||
091a6eb0 502 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 503
091a6eb0 504 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 505 fi
70c7ac22 506
2cd9de3e 507 # Copy "update" setting when it is not set yet
ac1fbbda
JH
508 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
509 test -n "$upd" &&
510 test -z "$(git config submodule."$name".update)"
511 then
512 case "$upd" in
efa8fd7e 513 checkout | rebase | merge | none)
ac1fbbda
JH
514 ;; # known modes of updating
515 *)
516 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
517 upd=none
518 ;;
519 esac
520 git config submodule."$name".update "$upd" ||
521 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
522 fi
70c7ac22
LH
523 done
524}
525
cf419828
JL
526#
527# Unregister submodules from .git/config and remove their work tree
528#
529# $@ = requested paths (use '.' to deinit all submodules)
530#
531cmd_deinit()
532{
533 # parse $args after "submodule ... deinit".
534 while test $# -ne 0
535 do
536 case "$1" in
537 -f|--force)
538 force=$1
539 ;;
540 -q|--quiet)
541 GIT_QUIET=1
542 ;;
543 --)
544 shift
545 break
546 ;;
547 -*)
548 usage
549 ;;
550 *)
551 break
552 ;;
553 esac
554 shift
555 done
556
557 if test $# = 0
558 then
559 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
560 fi
561
74703a1e 562 git submodule--helper list --prefix "$wt_prefix" "$@" |
cf419828
JL
563 while read mode sha1 stage sm_path
564 do
565 die_if_unmatched "$mode"
0ea306ef 566 name=$(git submodule--helper name "$sm_path") || exit
cf419828 567
091a6eb0
JK
568 displaypath=$(relative_path "$sm_path")
569
cf419828
JL
570 # Remove the submodule work tree (unless the user already did it)
571 if test -d "$sm_path"
572 then
573 # Protect submodules containing a .git directory
574 if test -d "$sm_path/.git"
575 then
091a6eb0 576 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
577 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
578 fi
579
580 if test -z "$force"
581 then
7b294bf4 582 git rm -qn "$sm_path" ||
091a6eb0 583 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 584 fi
7b294bf4 585 rm -rf "$sm_path" &&
091a6eb0
JK
586 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
587 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
588 fi
589
091a6eb0 590 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
591
592 # Remove the .git/config entries (unless the user already did it)
593 if test -n "$(git config --get-regexp submodule."$name\.")"
594 then
595 # Remove the whole section so we have a clean state when
596 # the user later decides to init this submodule again
597 url=$(git config submodule."$name".url)
598 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 599 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
600 fi
601 done
602}
603
70c7ac22 604#
211b7f19 605# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
606#
607# $@ = requested paths (default to all)
608#
23a485e3 609cmd_update()
70c7ac22 610{
5c08dbbd
JH
611 # parse $args after "submodule ... update".
612 while test $# -ne 0
613 do
614 case "$1" in
615 -q|--quiet)
2e6a30ef 616 GIT_QUIET=1
5c08dbbd 617 ;;
be4d2c83 618 -i|--init)
d92a3959 619 init=1
be4d2c83 620 ;;
06b1abb5
TK
621 --remote)
622 remote=1
623 ;;
31ca3ac3 624 -N|--no-fetch)
31ca3ac3
FF
625 nofetch=1
626 ;;
9db31bdf
NMC
627 -f|--force)
628 force=$1
629 ;;
ca2cedba 630 -r|--rebase)
32948425 631 update="rebase"
ca2cedba 632 ;;
d92a3959
MT
633 --reference)
634 case "$2" in '') usage ;; esac
635 reference="--reference=$2"
98dbe63d 636 shift
d92a3959
MT
637 ;;
638 --reference=*)
639 reference="$1"
d92a3959 640 ;;
42b49178 641 -m|--merge)
42b49178
JH
642 update="merge"
643 ;;
b13fd5c1 644 --recursive)
b13fd5c1
JH
645 recursive=1
646 ;;
efc5fb6a
JH
647 --checkout)
648 update="checkout"
649 ;;
275cd184
FG
650 --depth)
651 case "$2" in '') usage ;; esac
652 depth="--depth=$2"
653 shift
654 ;;
655 --depth=*)
656 depth=$1
657 ;;
5c08dbbd
JH
658 --)
659 shift
660 break
661 ;;
662 -*)
663 usage
664 ;;
665 *)
666 break
667 ;;
668 esac
98dbe63d 669 shift
5c08dbbd
JH
670 done
671
d92a3959
MT
672 if test -n "$init"
673 then
674 cmd_init "--" "$@" || return
675 fi
676
1b4735d9 677 cloned_modules=
74703a1e 678 git submodule--helper list --prefix "$wt_prefix" "$@" | {
15ffb7cd 679 err=
64394e3a 680 while read mode sha1 stage sm_path
70c7ac22 681 do
be9d0a3a 682 die_if_unmatched "$mode"
313ee0d6
NMC
683 if test "$stage" = U
684 then
75bf5e60 685 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
686 continue
687 fi
0ea306ef 688 name=$(git submodule--helper name "$sm_path") || exit
5be60078 689 url=$(git config submodule."$name".url)
d851ffb9 690 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
691 if ! test -z "$update"
692 then
693 update_module=$update
694 else
695 update_module=$(git config submodule."$name".update)
a2aed08b
TK
696 if test -z "$update_module"
697 then
698 update_module="checkout"
699 fi
efc5fb6a
JH
700 fi
701
091a6eb0
JK
702 displaypath=$(relative_path "$prefix$sm_path")
703
d851ffb9
JH
704 if test "$update_module" = "none"
705 then
091a6eb0 706 echo "Skipping submodule '$displaypath'"
efc5fb6a 707 continue
d851ffb9 708 fi
efc5fb6a 709
211b7f19 710 if test -z "$url"
70c7ac22
LH
711 then
712 # Only mention uninitialized submodules when its
713 # path have been specified
714 test "$#" != "0" &&
091a6eb0 715 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 716Maybe you want to use 'update --init'?")"
211b7f19
LH
717 continue
718 fi
719
496eeeb1 720 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
211b7f19 721 then
d10e3b42 722 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" ${reference:+"$reference"} ${depth:+"$depth"} || exit
1b4735d9 723 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
724 subsha1=
725 else
14111fc4 726 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 727 git rev-parse --verify HEAD) ||
091a6eb0 728 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 729 fi
211b7f19 730
06b1abb5
TK
731 if test -n "$remote"
732 then
733 if test -z "$nofetch"
734 then
735 # Fetch remote before determining tracking $sha1
14111fc4 736 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
06b1abb5
TK
737 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
738 fi
14111fc4
JK
739 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
740 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5
TK
741 git rev-parse --verify "${remote_name}/${branch}") ||
742 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
743 fi
744
496eeeb1 745 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 746 then
9db31bdf
NMC
747 subforce=$force
748 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 749 if test -z "$subsha1" && test -z "$force"
b9b378a0 750 then
9db31bdf 751 subforce="-f"
b9b378a0 752 fi
31ca3ac3
FF
753
754 if test -z "$nofetch"
755 then
e5f522d6
JL
756 # Run fetch only if $sha1 isn't present or it
757 # is not reachable from a ref.
14111fc4 758 (sanitize_submodule_env; cd "$sm_path" &&
f5799e05 759 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 760 test -z "$rev") || git-fetch)) ||
091a6eb0 761 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
762 fi
763
1b4735d9
SO
764 # Is this something we just cloned?
765 case ";$cloned_modules;" in
766 *";$name;"*)
767 # then there is no local change to integrate
d851ffb9 768 update_module=checkout ;;
1b4735d9
SO
769 esac
770
877449c1 771 must_die_on_failure=
32948425 772 case "$update_module" in
a2aed08b
TK
773 checkout)
774 command="git checkout $subforce -q"
775 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
776 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
777 ;;
32948425
JH
778 rebase)
779 command="git rebase"
091a6eb0
JK
780 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
781 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 782 must_die_on_failure=yes
32948425 783 ;;
42b49178
JH
784 merge)
785 command="git merge"
091a6eb0
JK
786 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
787 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 788 must_die_on_failure=yes
42b49178 789 ;;
6cb5728c
CP
790 !*)
791 command="${update_module#!}"
b80fa842 792 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
6cb5728c
CP
793 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
794 must_die_on_failure=yes
795 ;;
32948425 796 *)
a2aed08b 797 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 798 esac
70c7ac22 799
14111fc4 800 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 801 then
ff968f03 802 say "$say_msg"
877449c1
JH
803 elif test -n "$must_die_on_failure"
804 then
ff968f03 805 die_with_status 2 "$die_msg"
15ffb7cd 806 else
ff968f03 807 err="${err};$die_msg"
877449c1 808 continue
15ffb7cd 809 fi
70c7ac22 810 fi
b13fd5c1
JH
811
812 if test -n "$recursive"
813 then
75bf5e60
WE
814 (
815 prefix="$prefix$sm_path/"
14111fc4 816 sanitize_submodule_env
75bf5e60 817 cd "$sm_path" &&
36141282 818 eval cmd_update
75bf5e60 819 )
15ffb7cd
FG
820 res=$?
821 if test $res -gt 0
822 then
091a6eb0 823 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
824 if test $res -eq 1
825 then
ff968f03 826 err="${err};$die_msg"
15ffb7cd
FG
827 continue
828 else
ff968f03 829 die_with_status $res "$die_msg"
15ffb7cd
FG
830 fi
831 fi
b13fd5c1 832 fi
70c7ac22 833 done
15ffb7cd
FG
834
835 if test -n "$err"
836 then
837 OIFS=$IFS
838 IFS=';'
839 for e in $err
840 do
841 if test -n "$e"
842 then
843 echo >&2 "$e"
844 fi
845 done
846 IFS=$OIFS
847 exit 1
848 fi
849 }
70c7ac22
LH
850}
851
bffe71f4
EM
852set_name_rev () {
853 revname=$( (
14111fc4 854 sanitize_submodule_env
bffe71f4 855 cd "$1" && {
5be60078
JH
856 git describe "$2" 2>/dev/null ||
857 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
858 git describe --contains "$2" 2>/dev/null ||
859 git describe --all --always "$2"
bffe71f4
EM
860 }
861 ) )
862 test -z "$revname" || revname=" ($revname)"
863}
28f9af5d
PY
864#
865# Show commit summary for submodules in index or working tree
866#
867# If '--cached' is given, show summary between index and given commit,
868# or between working tree and given commit
869#
870# $@ = [commit (default 'HEAD'),] requested paths (default all)
871#
872cmd_summary() {
f2dc06a3 873 summary_limit=-1
d0f64dd4 874 for_status=
1c244f6e 875 diff_cmd=diff-index
f2dc06a3 876
28f9af5d
PY
877 # parse $args after "submodule ... summary".
878 while test $# -ne 0
879 do
880 case "$1" in
881 --cached)
882 cached="$1"
883 ;;
1c244f6e
JL
884 --files)
885 files="$1"
886 ;;
d0f64dd4
PY
887 --for-status)
888 for_status="$1"
889 ;;
f2dc06a3 890 -n|--summary-limit)
862ae6cd
RS
891 summary_limit="$2"
892 isnumber "$summary_limit" || usage
f2dc06a3
PY
893 shift
894 ;;
862ae6cd
RS
895 --summary-limit=*)
896 summary_limit="${1#--summary-limit=}"
897 isnumber "$summary_limit" || usage
898 ;;
28f9af5d
PY
899 --)
900 shift
901 break
902 ;;
903 -*)
904 usage
905 ;;
906 *)
907 break
908 ;;
909 esac
910 shift
911 done
bffe71f4 912
f2dc06a3
PY
913 test $summary_limit = 0 && return
914
3deea89c 915 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
916 then
917 head=$rev
caa9c3ca 918 test $# = 0 || shift
496eeeb1 919 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 920 then
14e940d7
JH
921 # before the first commit: compare with an empty tree
922 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 923 test -z "$1" || shift
28f9af5d 924 else
3deea89c 925 head="HEAD"
28f9af5d
PY
926 fi
927
1c244f6e
JL
928 if [ -n "$files" ]
929 then
930 test -n "$cached" &&
465d6a00 931 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
932 diff_cmd=diff-files
933 head=
934 fi
935
28f9af5d 936 cd_to_toplevel
091a6eb0 937 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 938 # Get modified modules cared by user
18076502 939 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 940 sane_egrep '^:([0-7]* )?160000' |
2be94509 941 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
942 do
943 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
944 if test "$status" = D || test "$status" = T
945 then
6a066230 946 printf '%s\n' "$sm_path"
496eeeb1
EP
947 continue
948 fi
927b26f8 949 # Respect the ignore setting for --for-status.
950 if test -n "$for_status"
951 then
0ea306ef 952 name=$(git submodule--helper name "$sm_path")
927b26f8 953 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 954 test $status != A && test $ignore_config = all && continue
927b26f8 955 fi
28f9af5d 956 # Also show added or modified modules which are checked out
2be94509 957 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 958 printf '%s\n' "$sm_path"
28f9af5d
PY
959 done
960 )
1cb639e6 961
d0f64dd4
PY
962 test -z "$modules" && return
963
18076502 964 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 965 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
966 cut -c2- |
967 while read mod_src mod_dst sha1_src sha1_dst status name
968 do
969 if test -z "$cached" &&
970 test $sha1_dst = 0000000000000000000000000000000000000000
971 then
972 case "$mod_dst" in
973 160000)
974 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
975 ;;
976 100644 | 100755 | 120000)
977 sha1_dst=$(git hash-object $name)
978 ;;
979 000000)
980 ;; # removed
981 *)
982 # unexpected type
6ff875c5 983 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
984 continue ;;
985 esac
986 fi
987 missing_src=
988 missing_dst=
989
990 test $mod_src = 160000 &&
30353a40 991 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
992 missing_src=t
993
994 test $mod_dst = 160000 &&
30353a40 995 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 996 missing_dst=t
bffe71f4 997
091a6eb0
JK
998 display_name=$(relative_path "$name")
999
1cb639e6
PY
1000 total_commits=
1001 case "$missing_src,$missing_dst" in
1002 t,)
091a6eb0 1003 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1004 ;;
1005 ,t)
091a6eb0 1006 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1007 ;;
1008 t,t)
091a6eb0 1009 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1010 ;;
1011 *)
1012 errmsg=
1013 total_commits=$(
496eeeb1 1014 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
1015 then
1016 range="$sha1_src...$sha1_dst"
1017 elif test $mod_src = 160000
1018 then
1019 range=$sha1_src
1020 else
1021 range=$sha1_dst
1022 fi
1023 GIT_DIR="$name/.git" \
b0e621ad 1024 git rev-list --first-parent $range -- | wc -l
1cb639e6 1025 )
eed35595 1026 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1027 ;;
1028 esac
1029
1030 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1031 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1032 if test $status = T
1033 then
b3e73449
ÆAB
1034 blob="$(gettext "blob")"
1035 submodule="$(gettext "submodule")"
1cb639e6
PY
1036 if test $mod_dst = 160000
1037 then
091a6eb0 1038 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1039 else
091a6eb0 1040 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1041 fi
1042 else
091a6eb0 1043 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1044 fi
1045 if test -n "$errmsg"
1046 then
1047 # Don't give error msg for modification whose dst is not submodule
1048 # i.e. deleted or changed to blob
1049 test $mod_dst = 160000 && echo "$errmsg"
1050 else
496eeeb1 1051 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1052 then
f2dc06a3
PY
1053 limit=
1054 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1055 GIT_DIR="$name/.git" \
f2dc06a3 1056 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1057 --first-parent $sha1_src...$sha1_dst
1058 elif test $mod_dst = 160000
1059 then
1060 GIT_DIR="$name/.git" \
1061 git log --pretty='format: > %s' -1 $sha1_dst
1062 else
1063 GIT_DIR="$name/.git" \
1064 git log --pretty='format: < %s' -1 $sha1_src
1065 fi
1066 echo
1067 fi
1068 echo
3ba7407b 1069 done
28f9af5d 1070}
70c7ac22 1071#
941987a5 1072# List all submodules, prefixed with:
70c7ac22
LH
1073# - submodule not initialized
1074# + different revision checked out
1075#
1076# If --cached was specified the revision in the index will be printed
1077# instead of the currently checked out revision.
1078#
1079# $@ = requested paths (default to all)
1080#
23a485e3 1081cmd_status()
70c7ac22 1082{
5c08dbbd
JH
1083 # parse $args after "submodule ... status".
1084 while test $# -ne 0
1085 do
1086 case "$1" in
1087 -q|--quiet)
2e6a30ef 1088 GIT_QUIET=1
5c08dbbd
JH
1089 ;;
1090 --cached)
1091 cached=1
1092 ;;
64b19ffe
JH
1093 --recursive)
1094 recursive=1
1095 ;;
5c08dbbd
JH
1096 --)
1097 shift
1098 break
1099 ;;
1100 -*)
1101 usage
1102 ;;
1103 *)
1104 break
1105 ;;
1106 esac
1107 shift
1108 done
1109
74703a1e 1110 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1111 while read mode sha1 stage sm_path
70c7ac22 1112 do
be9d0a3a 1113 die_if_unmatched "$mode"
0ea306ef 1114 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1115 url=$(git config submodule."$name".url)
091a6eb0 1116 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1117 if test "$stage" = U
1118 then
1119 say "U$sha1 $displaypath"
1120 continue
1121 fi
496eeeb1
EP
1122 if test -z "$url" ||
1123 {
1124 ! test -d "$sm_path"/.git &&
1125 ! test -f "$sm_path"/.git
1126 }
70c7ac22 1127 then
64b19ffe 1128 say "-$sha1 $displaypath"
70c7ac22
LH
1129 continue;
1130 fi
64394e3a 1131 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1132 then
b545cd15 1133 set_name_rev "$sm_path" "$sha1"
64b19ffe 1134 say " $sha1 $displaypath$revname"
70c7ac22
LH
1135 else
1136 if test -z "$cached"
1137 then
14111fc4 1138 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1139 fi
b545cd15 1140 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1141 say "+$sha1 $displaypath$revname"
1142 fi
1143
1144 if test -n "$recursive"
1145 then
1146 (
1147 prefix="$displaypath/"
14111fc4 1148 sanitize_submodule_env
64394e3a 1149 cd "$sm_path" &&
e15bec0e 1150 eval cmd_status
64b19ffe 1151 ) ||
64394e3a 1152 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1153 fi
1154 done
1155}
2327f61e
DA
1156#
1157# Sync remote urls for submodules
1158# This makes the value for remote.$remote.url match the value
1159# specified in .gitmodules.
1160#
1161cmd_sync()
1162{
1163 while test $# -ne 0
1164 do
1165 case "$1" in
1166 -q|--quiet)
2e6a30ef 1167 GIT_QUIET=1
2327f61e
DA
1168 shift
1169 ;;
82f49f29
PH
1170 --recursive)
1171 recursive=1
1172 shift
1173 ;;
2327f61e
DA
1174 --)
1175 shift
1176 break
1177 ;;
1178 -*)
1179 usage
1180 ;;
1181 *)
1182 break
1183 ;;
1184 esac
1185 done
1186 cd_to_toplevel
74703a1e 1187 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1188 while read mode sha1 stage sm_path
2327f61e 1189 do
be9d0a3a 1190 die_if_unmatched "$mode"
0ea306ef 1191 name=$(git submodule--helper name "$sm_path")
2327f61e 1192 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1193
1194 # Possibly a url relative to parent
1195 case "$url" in
1196 ./*|../*)
967b2c66
JS
1197 # rewrite foo/bar as ../.. to find path from
1198 # submodule work tree to superproject work tree
6a066230 1199 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1200 # guarantee a trailing /
1201 up_path=${up_path%/}/ &&
1202 # path from submodule work tree to submodule origin repo
1203 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1204 # path from superproject work tree to submodule origin repo
1205 super_config_url=$(resolve_relative_url "$url") || exit
1206 ;;
1207 *)
1208 sub_origin_url="$url"
1209 super_config_url="$url"
baede9f8
JH
1210 ;;
1211 esac
1212
ccee6086 1213 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1214 then
091a6eb0
JK
1215 displaypath=$(relative_path "$prefix$sm_path")
1216 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1217 git config submodule."$name".url "$super_config_url"
ccee6086 1218
64394e3a 1219 if test -e "$sm_path"/.git
ccee6086
JH
1220 then
1221 (
14111fc4 1222 sanitize_submodule_env
64394e3a 1223 cd "$sm_path"
ccee6086 1224 remote=$(get_default_remote)
967b2c66 1225 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1226
1227 if test -n "$recursive"
1228 then
1229 prefix="$prefix$sm_path/"
1230 eval cmd_sync
1231 fi
ccee6086
JH
1232 )
1233 fi
2327f61e
DA
1234 fi
1235 done
1236}
70c7ac22 1237
5c08dbbd
JH
1238# This loop parses the command line arguments to find the
1239# subcommand name to dispatch. Parsing of the subcommand specific
1240# options are primarily done by the subcommand implementations.
1241# Subcommand specific options such as --branch and --cached are
1242# parsed here as well, for backward compatibility.
1243
1244while test $# != 0 && test -z "$command"
70c7ac22
LH
1245do
1246 case "$1" in
cf419828 1247 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1248 command=$1
70c7ac22
LH
1249 ;;
1250 -q|--quiet)
2e6a30ef 1251 GIT_QUIET=1
70c7ac22 1252 ;;
ecda0723
SV
1253 -b|--branch)
1254 case "$2" in
1255 '')
1256 usage
1257 ;;
1258 esac
1259 branch="$2"; shift
1260 ;;
70c7ac22 1261 --cached)
28f9af5d 1262 cached="$1"
70c7ac22
LH
1263 ;;
1264 --)
1265 break
1266 ;;
1267 -*)
1268 usage
1269 ;;
1270 *)
1271 break
1272 ;;
1273 esac
1274 shift
1275done
1276
5c08dbbd 1277# No command word defaults to "status"
af9c9f97
RR
1278if test -z "$command"
1279then
1280 if test $# = 0
1281 then
1282 command=status
1283 else
1284 usage
1285 fi
1286fi
5c08dbbd
JH
1287
1288# "-b branch" is accepted only by "add"
1289if test -n "$branch" && test "$command" != add
1290then
ecda0723 1291 usage
5c08dbbd
JH
1292fi
1293
28f9af5d 1294# "--cached" is accepted only by "status" and "summary"
496eeeb1 1295if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1296then
70c7ac22 1297 usage
5c08dbbd
JH
1298fi
1299
1300"cmd_$command" "$@"